<cv-filters>

	<div class="block-filters" id="cv-filters">

		<div class="block-filters-body">

	        <div class="block-info-heading mrg-bottom-md">
	            <h4 class="block-info-title-1">ΦΙΛΤΡΑ ΑΝΑΖΗΤΗΣΗΣ</h4>
	            <a href="#" class="close hidden-lg hidden-md" onclick="{ close_filters }">&times;</a>
	        </div>

	        <a href="#" class="clear-filters" onclick="{ clear_filters }">Καθαρισμός επιλογών</a>

	        <div class="filters-group">
	            <legend>Κατηγορία</legend>
	            <div class="form-group">
	                <control-multy-select data-ref="categories" source="categories" root="1" vertical="true" dropdown="true" onchangehandler="{ categories_change }" oninitialize={ categories_change } placeholder="ονομα κατηγορίας"></control-multy-select>
	            </div>
	        </div>


	        <div class="filters-group">
	            <legend>Όνομα</legend>
	            <div class="form-group mrg-bottom-md">
	                <input type="text" class="form-control" data-ref="name" value="{ state.name }" onchange="{ input_change }" placeholder="επίθετο ή όνομα">
	            </div>

	            <!-- <legend>Εκπαίδευση</legend>
	            <div class="form-group mrg-bottom-md">
	                <select class="form-control" data-ref="education" onchange="{ input_change }">
	                	<option value="">-- επιλογή --</option>
	                	<option each="{ education in state.educations }" value="{ education }" selected="{ state.education == education }">{ education }</option>
	                </select>
	            </div> -->

	            <legend>Γλώσσες</legend>
	            <div class="form-group mrg-bottom-md">
	                <input type="text" class="form-control" data-ref="languages" value="{ state.languages }" onchange="{ input_change }" placeholder="π.χ. αγγλικά,γαλλικά">
	            </div>

	            <div class="filters-group" if="{ state.filters.length }">
			 		<legend>Σύνθετη Αναζήτηση</legend>
			 		<div class="filter-option" each="{ group in state.filters }">
			 			<a href="#" class="filter-option-title" onclick="{ toggle_filter_option }">
			 				<span>{ group.expanded ? '-' : '+' }</span>{ group.title }
						</a>
						<div class="filter-option-content">
							<div class="checkbox" each="{ option in group.options }" if="{ group.expanded || option.checked }">
								<label>
									<input type="checkbox" onclick="{ option_click }" checked="{ option.checked }">
									{ option.label }
								</label>
							</div>
						</div>
					</div>
			 	</div>

	            <!-- <legend>Επισήμανση</legend>
	            <div class="form-group mrg-bottom-md">
	                <select class="form-control" data-ref="rate" onchange="{ input_change }">
	                    <option value="">-- επιλογή --</option>
	                    <option value="1" selected="{ state.rate == 1 }">1 αστέρι</option>
	                    <option value="2" selected="{ state.rate == 2 }">2 αστέρια</option>
	                    <option value="2" selected="{ state.rate == 3 }">3 αστέρια</option>
	                </select>
	            </div> -->
	        </div>

	        
	        <a href="#" class="btn btn-secondary btn-block mrg-bottom-md" onclick="{ apply_filters }">ΕΦΑΡΜΟΓΗ</a>
	        
	        <hr>

	        <a href="#" class="clear-filters mrg-bottom-none" onclick="{ clear_filters }">Καθαρισμός επιλογών</a>

	    </div>
    </div>

    <script>
    	this.state = {
    		categories: [],

    		filters: [],

			name: "",
			//education: "",
			languages: "",
			//rate: "",
    	}


    	this.close_filters = event => {
			console.log("close_filters");
			event.preventDefault();

			$('#cv-filters').fadeOut(200);
		}


		this.input_change = event => {
			this.state[event.target.dataset.ref] = event.target.value;
		}


		this.categories_change = () => {
			console.log("categories_change");
			this.state.categories = this.refs.categories.get_values();
			console.log(this.state.categories);
			this.update();
		}


		/* Filter options handlers */

		this.toggle_filter_option = event => {
			event.preventDefault();
			event.item.group.expanded = !event.item.group.expanded;
		}


		this.option_click = event => {
			//event.preventDefault();
			console.log(event.item.option);
			event.item.option.checked = !event.item.option.checked;
		}


		// create the url with the filter parameters
		this.url_parameters = () => {

			var url = "/cvs";
			var params = "";

			var categories = this.refs.categories.get_values();
			if (categories.length) {
				params = "?categories=" + categories.join(",");
			}

			if (this.state.name) {
				params+= (params ? "&" : "?") + "name=" + this.state.name;
			}
			// if (this.state.education) {
			// 	params+= (params ? "&" : "?") + "education=" + this.state.education;
			// }
			if (this.state.languages) {
				// split commas or spaces
				var languages = "";
				var array = this.state.languages.split(/,| /);
				array.map( lang => {
					languages+= (languages ? "," : "") + lang;
				})
				params+= (params ? "&" : "?") + "languages=" + languages;
			}
			// if (this.state.rate) {
			// 	params+= (params ? "&" : "?") + "rate=" + this.state.rate;
			// }


			this.state.filters.map( group => {
				var options = "";

				group.options.map( option => {
					if (option.checked) {
				 		options+= (options ? "," : "") + option.value;
				 	}
				});

				if (options) {
					params+= (params ? "&" : "?") + group.name + "=" + options;
				}
			});
			

			return url + params;
		}


		this.apply_filters = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			//console.log(this.url_parameters()); return false;
			window.open(window.location.protocol + "//" + window.location.hostname + this.url_parameters(), "_self");
		}


		this.clear_filters = event => {
			event.preventDefault();	

			this.refs.categories.clear();
			this.state.name = "";
			this.state.languages = "";

			this.state.filters.map( group => {
				group.options.map( option => {
					option.checked = false;
				});
			});

			this.update();
			this.apply_filters();
		}


		this.on("mount", function() {
			console.log("mount");
			console.log(riot_data);

			// set categories to show on filters
			this.refs.categories.set_root(1);
			this.refs.categories.set_values(riot_data.categories);

			this.state.name = riot_data.name;
			//this.state.education = riot_data.education;
			this.state.languages = riot_data.languages;
			//this.state.rate = riot_data.rate;

			var education = [];
			if (riot_data.education) {
				education = riot_data.education.split(",");
			}

			var rate = [];
			if (riot_data.rate) {
				rate = riot_data.rate.split(",");
				console.log("rate");
				console.log(rate);
			}

			this.state.filters = [
				{
					title: 'Εκπαίδευση',
					name: 'education',
					expanded: false,
					options: [
						{ label:"Απολυτήριο Λυκείου", value:"Απολυτήριο Λυκείου", checked:education.indexOf("Απολυτήριο Λυκείου") > -1 },
						{ label:"ΙΕΚ", value:"ΙΕΚ", checked:education.indexOf("ΙΕΚ") > -1 },
						{ label:"Πανεπιστήμιο", value:"Πανεπιστήμιο", checked:education.indexOf("Πανεπιστήμιο") > -1 },
						{ label:"Κολέγιο", value:"Κολέγιο", checked:education.indexOf("Κολέγιο") > -1 },
						{ label:"Μεταπτυχιακό", value:"Μεταπτυχιακό", checked:education.indexOf("Μεταπτυχιακό") > -1 },
						{ label:"Διδακτορικό", value:"Διδακτορικό", checked:education.indexOf("Διδακτορικό") > -1 },
					]
				},{
					title: 'Επισήμανση',
					name: 'rate',
					expanded: false,
					options: [
						{ label:"1 αστέρι", value:1, checked:rate.indexOf("1") > -1 },
						{ label:"2 αστέρια", value:2, checked:rate.indexOf("2") > -1 },
						{ label:"3 αστέρια", value:3, checked:rate.indexOf("3") > -1 },
					]
				}
			];


			this.update();

			console.log(this.state);


			// filters toggler handler
			$('.filters-toggler').bind("click", function(event) {
				event.preventDefault();
				
				if ($('#cv-filters').is("visible")) {
					$('#cv-filters').fadeOut(200);
				} else {
					$('#cv-filters').fadeIn(200);
				}
			})

		});

    </script>
</cv-filters>